/*
 * kerntypes.c
 *
 * Dummy module that includes headers for all kernel types of interest.
 * The kernel type information is used by the lcrash utility when
 * analyzing system crash dumps or the live system. Using the type
 * information for the running system, rather than kernel header files,
 * makes for a more flexible and robust analysis tool.
 *
 * This source code is released under the GNU GPL.
 */

#ifndef __KERNEL__
#define __KERNEL__
#endif

/* General linux types */

#include <linux/autoconf.h>
#include <linux/mm.h>
#include <linux/config.h>
#include <linux/utsname.h>
#include <linux/module.h>
#include <linux/sched.h>
#include <linux/sched_runqueue.h>
#include <linux/compile.h>

#ifdef CONFIG_ARCH_S390

       /* s390 specific types */

       #include <asm/lowcore.h>
       #include <asm/debug.h>
       #include <asm/irq.h>
       #include <asm/io.h>

       #if defined (CONFIG_DASD) || defined (CONFIG_DASD_MODULE)
	       #include "../drivers/s390/block/dasd_int.h"
       #endif /* CONFIG_DASD */

       #if defined (CONFIG_QDIO) || defined (CONFIG_QDIO_MODULE)
	       #include "asm/qdio.h"
       #endif /* CONFIG_QDIO */

#endif /* CONFIG_ARCH_S390 */

void
kerntypes_dummy(void)
{
}
